(define-module (tests test-eastasian-locale)
  #:use-module (uniseg eastasian locale)
  #:use-module (srfi srfi-64))

(test-begin "test-eastasian-locale")

(define (test-eastasian-locale expected charset)
  (test-equal
      (format #f "check ~a" charset)
    expected
    (eastasian-locale? charset)))

(define data
  '((#f "foo@cjk_narrow")
    (#f "foo@cjk")
    (#f "utf-8@cjk")
    (#f "C")
    (#f "POSIX")
    (#f "C.UTF-8")
    (#t "ja_JP.UTF-8")
    (#t "ja_JP.CP932")
    (#f "en_US.UTF-8")))

(for-each (λ (p) (apply test-eastasian-locale p)) data)

(test-end "test-eastasian-locale")
